Copyright (c) 2002-2004 Infrae. All rights reserved.
See also LICENSE.txt

Silva changes

  1.1

    Features added

      - Allowed access to the cleanup adapter from Python scripts.

      - Streamlined the creation of XSLT renderers.

      - All objects with renderers registered for them have a way to
        turn new-style rendering off explicitly for that object in
        particular (not just in renderer registry).

    Bugs fixed

      - Replaced print statement in Indexer for a LOG entry.

      - The Indexer could break when the content tree it indexed contains
        Silva Publications.

      - Protect methods on the service_files.

      - Content publication state is now not touched anymore when imported
        using *.zexp files in the ZMI.

      - zip-file XML import/export of Silva root should now work.

      - Unused XSLT support cruft has been cleaned up.

      - Fixed problem with very long titles and ids in lookup screens, they're
        truncated now

      - Ghosts and ghost folders should import properly with zip file import.

    Removals

      - Remnant of SQLDataSource removed. Use SilvaExternalSources instead.
        (SQLDataSource was deprecated since version 0.9.3).

      - Remnants of old archive file import code (for bulk creation of
        assets) has been removed. Use the archivefileimport adapter instead.

  1.1 beta 2

    Features added

      - Revision of the XSLT support so that it can work with any
        object in Silva, not just Silva Document. The properties tab
        and service_renderer_registry also now take this into
        account. If you're upgrading from 1.1b1, please remove
        service_renderer_registry in the ZMI and do a refresh all in
        service_extensions to install a new one.

    Bugs fixed

      - Remnants of old parser code in SilvaDocument (silvaparser.py,
        search.py) and all references to it have been removed. In
        EditorSupportNested the render_links method has been removed -
        this might break old extensions.

      - Remove a memory leak from XSLT support.

      - Some fixes for the full-media import/export system.

      - The 'get link reference' buttons in the forms-based editor now
        return the new-style HTML subset references.

      - The forms-based editor now highlights index items correctly in
        nested lists and tables.

      - Fixed the rename form for objects with no title. 

  1.1 beta 1

    Features added

      - XSLT support for rendering Silva objects. See
        doc/renderers_howto.txt for more information.

      - New parser for SilvaDocument forms-based editor, using a HTML
        subset instead of the old-style method using special
        characters.

      - A new XML export/system that can also export and import asset
        data.

      - abbr and acronym support for both forms editor and Kupu.

      - Implemented get_public_tree_all(depth) method.

    Bugs fixed

      - Silva File and Image asset use settings from the 'nearest' (by
        acquisition) service_files again.

      - Do not copy over properties anymore when changing a folder to
        publication or back. Silva does not use properties anymore.

      - Properties tab for Ghost Folder works again.

      - Fixed bug in images that caused a ZODB transaction on every public
        view.

      - Fixed kupu transformation bug that made paragraph type not
        come through on save.

      - The target attribute was not taken into account in the silva
        xml -> kupu html transformation. Fixed.

      - Fixed unicode issues in Groups support. This is only an issue
        for Membership extensions that allow non-ascii characters in
        their group names, for instance the ones based on LDAP. Core
        groups support is not affected by this change.

  1.0 final
  
    Bugs fixed

      - Made the 0.9.3-1.0 Image upgrade even more forgiving, basically it
        will now not break on anything anymore, it will print a warning to
        the zLOG on every exception.

      - Problem in Kupu transformations that made 'spurious' <p> elements 
        without content appear on the page.

      - Problem in Kupu transformations that made <div>'s get removed 
        completely from a document on save: now instead of removing it it's
        contents get converted and added to the document.

      - Issue 942: quotes in links around images broke the public view.

      - Added refresh all to update.

      - Issues 996 and 998: changed image links that pointed to the hires 
        version of the image, instead of pointing to <image>/hires_image
        they now point to <image>?hires.

      - Minor problem where the image edit form in the form editor
        didn't recognize a link as one to the hires version of the
        image.

      - Added test cases for get_creation_datetime() and
        get_modification_datetime() in SilvaObject. Also re-enabled and
        revised some tests that were commented out in test_SilvaObject.

      - Indexer is now updated when installation documentation.

  1.0 (release candidate 4)

    Bugs fixed

      - Removed problematic code from index_html Python script that
        accidentally triggered an experimental layout service.

      - Fixed bug in Kupu transformations that broke tables with incomplete
        alignment information.

      - Made the 0.9.3-1.0 Image upgrade a bit more forgiving, which may result
        in broken images but at least lets the upgrade continue.

  1.0 (release candidate 3)

    Bugs fixed

      - Fix bug where published document that is viewed anonymously is
        not accessible.
  
  1.0 (release candidate 2)

    Features added

      - Silva picks up version from version.txt in more places so that
        less code needs to be updated before each release.

    Bugs fixed

      - Empty index elements [[]] are now longer accepted.

      - Fixed bug in default layout template in accessibility
        (previous/next) links.

      - Closed content is publishable in publish tab.

  1.0 (release candidate 1)

    Features added

      - Kupu, a WYSIWYG editor for Silva Document. This editor offers
        a load of new features:

          - full Silva integration; Kupu knows about special Silva
            elements and saves Silva XML

          - Copy and paste HTML from any source into Kupu.

          - works in Internet Explorer (5.5 and higher) and Mozilla

        Kupu was formerly known as Epoz 1.0.
    
      - Extensive documentation released along with Silva, and can be
        automatically installed.

      - All images of a Silva Image asset are stored in the filesystem if
        ExtFile is available and the corresponding option is set in
        service_files. Also better support for ExtFile's static serving was
        introduced. service_files allows to convert the storage method of
        all Silva Image assets.

      - Image scaling supports "keep aspect ratio" now. You can scale with
        120x* or *x211 to fix width or height.

      - An Image has a thumbnail now, retrievable via foo.jpg?thumbnail.

      - Cropper tool - Silva now provides facilities for cropping
        images. This tool combines with the scaling possibilities to
        give authors the means to both scale and resize a high
        resolution image to web format.
  
      - Images can be viewed without the /image at the end (issue
        594), the high resolution version can be retrieved via
        foo.jpg?hires.

      - Supporting a newer, improved version of ExtFile.

      - Performance improvements in contents screen for folders, icon
        presentation, and metadata system.

      - Numerous tweaks in the UI.

      - Revision of the archive file import (i.e. zipfile import)
        functionality. Mimetypes can be registered for specific Asset
        types. The importer will create Assets depending on the mimetype.

      - Silva now should deliver the right mime type for HEAD requests.

    Bugs fixed

      - When run with Python 2.3 in 2.7 (not yet recommended by Infrae
        for Silva 1.0), suppress source code encoding warnings when
        starting up.

      - Another problem with the upgrade code for handling index elements,
        which causes a few of them to be missed, has been repaired.

      - Ghost Folders now can be added by Editors (required Manager role
        previously)

      - Groups are installable as specified in the UI (no more KeyError).

      - The File asset behaves more like the Image asset, where the URL
        to the object now will return the actual data. This obsoletes
        the need for URL's like "path/to/some/file/download'.

      - A long standing problem with occasional InvalidObjectReference
        errors when installing or refreshing Silva should now be
        fixed.

  0.9.3.4
  
    Bugs fixed

      - A problem in the upgrade code handling index elements in Silva
        Documents was repaired.

  0.9.3.3

    Bugs fixed

      - Smaller bugfixes in the silvaparser.

      - created a new method addAddable on ExtensionRegistry. This makes 
        it possible (again) to add classes to Silva without being required
        to name your class the same as the module name (which the 
        registerClass method needs). You simply register your class
        the normal way with Zope, and then invoke addAddable for its
        meta type.
    
      - Fixed acquisition for viewing locally defined roles on Silva
        objects. (For instance: if user1 has editor role on pub1, and not
        on pub2, viewing /pub1/pub2/foo/tab_access shouldn't show user1
        as an editor, and now doesn't).

  0.9.3.2

    Bugs fixed

      - Make render_icon create absolute URLs again for better
        cacheability.

      - Fixed the silva parser where a specific portnumber in the URL
        would not get recognized.

      - Improved link parser for anchors and query fragments.

  0.9.3.1

    Bugs fixed

      - Improvements in the upgrade code, esp. for large databases. 
    
      - Fixed bug in displaying the "allowed" addables.

  0.9.3

    Features Added

      Author visible changes

        - Container objects (e.g. Folder, Publications and the Silva
          Root) now have a title independent of the index document
          inside the container. The title is set during the creation
          of the container and can be changed using the rename button
          in the folder edit- or properties tab.

        - "Container policies" - When creating a new container object
           the author can choose the tpye of the index object being
           created, or not to create an index object at all. The
           options presented can be extended.
   
        - Import assets from a zipfile now creates Silva Folder for
          the zipfiles's directory structure.

        - Ghosts have a 'get reference' button now.
  
        - Silva Files now have their icon dependent on the
          content. I.e. you get a pdf icon if you uploaded a pf
          file. Currently there are icons for PDF, Word, Excel and
          PowerPoint.
      
        - Added GhostFolder: While a ghost haunts a content objects a
          GhostFolder haunts a container.
 
        - There is a new Link object for creating references to
          external sites that can become part of navigation and TOC.
          This link object redirects to the external site when
          accessed.

        - The Document text markup parser has been rewritten and is
          able to deal with more forms of input properly. There are a
          number of improvements to the way hyperlinks and indexables
          work.

        - New 'annotation' paragraph type.

        - Headings in Silva Documents now allow superscript, subscript
          and emphasis markup.

        - Numerous UI tweaks.
   
      Chief editor visible changes

        - Added IP Groups. This replaces the 'restriction by IP
          address' text area in tab_access.
  
        - Added Viewer + and Viewer ++ roles for higher view
          restrictions. Redid the user interface and underlying code
          for setting this.
          
      Site developer visible changes

        - Deprecated SQL Data Source assets in favor of the
          SilvaExternalSources extension. Existing SQL Data Source
          assets continue to work, but no new SQL Data Sources can be
          added to the Silva tree. In future Silva versions SQL Data
          Source assets may stop working. Add an external source in
          the editor using 'External Source' (not 'External Data',
          which is way to add the deprecrated SQL Data Source assets).

        - Improved virtual hosting support. Both the public screens as
          well as the Silva edit screens should behave better in the
          presence of virtual hosting. Public view caching such as for
          Silva Document has also been made virtual host aware.
       
        - Documents now index title along with document XML contents
          in fulltext indexing.

        - Error messages in public sites should now be shown within
          the context of the public template (if
          standard_error_message is replaced in the Silva root or if
          a new Silva root is created).

        - Some infrastructure is now in place to drive workflow
          from an outside process like a cron job. This is needed to
          keep the catalog and thus search functionality up to date if
          publication dates are set in the future or expiration dates
          are used.

        - DemoObject is removed from the core in favor of a (to be
          developed/updated) demo extension.

      Technical changes

        - Added API to membership system so that extra columns can be
          defined for lookup results by plugin membership components.

        - Merged silva.css and ploneCustom.css (removed ploneCustom)
          to reduce hits and processing.
        
        - service_utils went away. All functionality moved to
          mangle.py
    
        - Checks for valid IDs are all moved to a separate module.

        - Silva Document and editor functionality is split from the
          Silva core into a separate SilvaDocument product. This is
          still very much tied to the core in this release however, so
          changes are noted in this HISTORY file for the time being.

        - Silva Views machinery is split out from the Silva core into
          SilvaViews product.

        - New SilvaExternalSources product replacing both code element
          and SQLSource assets. This makes it possible to pass
          parameters to external sources (a feature missing in code
          element). They also plug into the document caching
          framework.
   
        - Added functionality to use CMFCore DirectoryView
          infrastructure instead of FileSystemSite, through the
          fssite.py module. Importing from the CMFCore is turned off
          right now, though.

          All uses of FileSystemSite functionality in Silva should now
          import through this module.

        - Errors that are displayed in the Silva user interface now
          don't result in ZODB database commits.

        - A new Silva unit testing framework that is based on the
          ZopeTestCase system
          (http://www.zope.org/Members/shh/ZopeTestCase) allows much
          higher performance and less hackery for running unit tests.
          See the README.txt in the tests directory for more information.
        
        - publication and modification datetime support is now not
          dependent on ZODB bobobase_modification_datetime anymore but
          is hooked into the metadata system.

    Bugs fixed

        - Fixed rare or edge-case situations in the Publish tab. UI
          improvements, bugfixes and some code optimizations.

        - Renaming publishables no longer changes ordering (issue 635)

        - In the Docma queues, the fullname of the job owner is now
          shown instead of the userid, which was seen as a security
          issue by some customers.

        - Fixed unicode issue when deleting a table column

        - XML export permissions rationalized: it is now accessible to
          people having ReadSilvaContent permission.

        - Access restriction by IP used to rely on Zope Properties;
          this doesn't happen anymore since we migrated to IP groups.

        - Some cleanups in what is indexed in the catalog.

        - Can add a new Silva root with non-ascii (latin1) characters
          in the title.


  0.9.2.6

    Bugs fixed

        - Fulltext also indexes title, not just XML content

        - Fixed some unicode errors in the EmailMessageService.

        - Cache is now bypassed if 'suppress_title' is in the request.

  0.9.2.5

    Features Added

        - Image elements in a Silva Document now have to possibility to
          link to the hires version or other URLs with a optional "_target".

    Bugs fixed

        - No Catalog indexes are created for Metadata fields which do not
          need indexing.

        - Metadata form and acquisition didn't work properly in all cases.

        - UI improvements in tab_edit and tab_publish

        - XML export of folders when the "export last version" option is
          checked, did not use correct Folder title.

        - Fixed two issues with the SQLDataSource and integer fields:
          the code doesn't try to convert the contents of the field to
          unicode anymore if it's not a plain string (fails with
          integers) and the code doesn't change the contents of the
          field to '' anymore when it's something else than None
          (previously it checked whether it resolved to true instead
          of checking for None).

        - View caching should now be more efficient as cachability
          check is now only made once for each new publish event. The
          view caching framework now also has some unit tests.

  0.9.2.4

    Features Added

        - Import assets from a zipfile now creates Silva Folder for the
          zipfiles's directory structure.

    Bugs fixed

        - Fixed bug where the widget caches were not cleared correctly
          upon deletion of a Document.

        - Fixed rare or edge-case situations in the Publish tab. UI
          improvements, bugfixes and some code optimizations.

        - SilvaMetadata contained a bug which actually made metadata
          cataloging fail. This has been fixed in SilvaMetadata
          0.7.2, so the only upgrade necessary is in fact of this
          dependency. For convenience we've also done a new Silva
          release, but the only thing it contains is one new test for
          getting metadata.

  0.9.2.3

    Bugs fixed

        - Authors can now create new document versions again. This was
          a permission setting problem. It can be fixed by going to
          service_extensions and pressing 'refresh' for the Silva
          core.

        - Fixed two issues with the SQLDataSource and integer fields:
          the code doesn't try to convert the contents of the field to
          unicode anymore if it's not a plain string (fails with
          integers) and the code doesn't change the contents of the
          field to '' anymore when it's something else than None
          (previously it checked whether it resolved to true instead
          of checking for None).

        - Fixed a whole host of issues related to indexing. Indexing
          of objects was both done incorrectly and the performance was
          too slow. test_catalog was added which can be used to test
          indexing correctness, and fixes were made where problems
          were found. Indexing performance was increased by:

            * Avoiding indexing something too frequently in the Silva
              core.

            * Improving Formulator so that TALES expressions are
              cached. This avoids a massive Python expression
              compilation overhead. Upgrade Formulator to version
              1.5.0 for a massive boost in indexing performance.

            * Fixing Silva metadata to avoid quadratic behavior while
              indexing. Previously, for n elements that are indexed,
              for each element indexing the data for the n indexes was
              accessed, resulting in quadratic behavior while indexing
              (n * n values were accessed per object). Upgrade SilvaMetadata
              to version 0.7.1 for another boost in indexing performance.

            * Fulltext indexing of unapproved versions is avoided.

            * Old versions should now not show up in the catalog anymore.

        - Fix icon rendering. It should now be faster and more
          browser-cache friendly.
 
        - Fixed unicode issue when deleting a table column.

        - A number of things fixed in 0.9.1.x have also been fixed
          for 0.9.2.

  0.9.2.2
 
    Bugs Fixed
                                                                       
        - get CSS style iteration right for containers only containing
          Assets (which otherwise would break the container view).
                                                                            
        - Add a silva root in the ploneCustom style sheet for the
          tabbar background images (which would not display if the
          silva root folder did not have 'silva' for id and be located
          directly in the zope root).
                                                                              
        - Be less aggressive about trying to add a Unicode Whitespace
          splitter, and accept if one is already there.

        - Changed check_reserved_ids() function in the content upgrade
          script from breadth-first to depth-first. This works better for
          content hierarchies where folders with an invalid id containing
          content also with invalid ids, are being renamed.

        - The metadata tab wouldn't show the metadata set's title when it
          was available.
 
  0.9.2.1
 
    Features added
 
        - Added support for ExternalEditor, Silva Files and Images can now
          be edited using your favorite editor
 
    Bugs Fixed
 
        - Fix bug where viewing content normally restricted by an
          AccessRestriction, could be viewed via a Ghost.
 
        - Pressing upgrade more than once now doesn't mess up object titles
          anymore
 
        - All content types should now have the correct metadata sets setup
          for them (led to a KeyError on 'silva-extra' in all of the views
          of those content types)

  0.9.2 

    Features Added

        - Bulk import of files (for File Assets) and/or images (for Image
          Assets) using a zipfile.

        - New metadata architecture, which provides multiple configurable
          metadata sets. Sets can defined on a per object type basis and
          uses the catalog to make this metadata searchable.

        - Unicode support. All content and meta data can contain any character
          defined by the unicode standard. On upgrade you have replace or
          update your index_html set the the correct encoding; the default
          index_html does this.

        - Sidebar caching. For performance reasons, the sidebar is now cached,
          making it possible to use it throughout the site without slowing
          down page rendering.
          
        - High resolution image support. If you have PIL installed images can
          be both converted to JPEG or PNG and arbitrary scaled for web
          presentation. The high resolution image can be used for printing. 

        - Asset references and code element references will now be relative
          paths if the Assets are in the same container the Document is in,
          or in a subcontainer of this container. If not, the path will be
          an absolute path.

        - Docma queue viewer is now on both import and export screen. On import
          only Silva XML files are shown, on export only Word documents.

        - Export screen prefills email address and description.

        - Single Document import/export

        - Markup character escapes (entities)

        - Titles are now associated to document versions, not documents
          themselves. Different versions can have different titles.
 
        - Some XMLWidgets related cleanups to the editor.

    Bugs Fixed

        - (SQL)Datasources can now only be placed by ChiefEditors and up
          (using a Datasource in a document is not affected by this), and
          (SQL)Datasources now work with unicode.

        - The widgets cache would be cleared correctly upon Document
          deletion. This could result in inconsistent Document editor states
          if this Document has an id earlier held by a Document now deleted.

        - Setting a TOC level would display one level too much.

        - Fixed problems arising from allowing to create content objects
          which may shadow important internal objects (issue321) or 
          cause unfriendly Zope error messages (issue189)

        - A number of minor bugs, mainly in UI.

  0.9.1.5
                                                                      
    Features Added
        
        - Added support for ExternalEditor, Silva Files and Images can
          now be edited using your favorite editor.

        - Bulk import of files (for File Assets) and/or images (for Image
          Assets) using a zipfile. Note though, that the 091 id
          checking is less tolerant compared to the 092 id checking.

                                                               
    Bugs Fixed
                                                                            
        - Removed "Asset reference" asset-type stickyness.
                                                                               
        - Fixed button for refresh queue when Docma is enabled.
                                                                               
        - Added a find_indexers utility (accesible through
          http://server/silva/edit/service_utils/find_indexers) to find all
          Indexer objects in use.
                                                                            
        - Help text opens in new browser window.
                                                                            
        - Indexer -all non-versioned content actually- can now be deleted.

        - Indexer objects now render the correct URLs in virtual host
          situations. Use the 'update index' in the edit tab of Indexer
          objects to get the Indexers up to date.

        - Setting a TOC level would display one level too much.

        - Pressing 'Export' in Document's status tab now takes a user to the
          export screen of the container so the user can indeed (as the text
          suggests) export to Docma as well as download the content.

  0.9.1.4

    Bugs Fixed

        - The UI for 'Access Restriction by Role' did not properly expose
          the possibility to set this role more restrictive on a lower
          level. (the pull down menu and button would have been disabled).

        - get_public_tree() would not do the right thing with the depth-
          level control argument.

  0.9.1.3

    Features Added

        - Alternating CSS classes in table rows for external data elements.

    Bugs Fixed

        - Fixed situation where authors could not move items to other
          positions in the folders.

        - Fixed bug where no asset could be added in the asset lookup
          dialog when no previous assets where available in this folder.

        - Images nested in tables now keep their <a href="..."> tag (if set
          on the image element).

        - Ghosts of Documents containing a TOC will render this TOC with
          the Ghost's container context and not with the container context
          of the target Document.

        - Fixed unwanted aquisition behaviour of Ghost paths and other
          improvements in the Ghost code.

  0.9.1.2

    Features Added

        - Backport of the Hi-res images support.

        - Backport of the multipe file repositories ability.

        - Backport of single Document import/export.

        - Asset references and code element references will now be relative
          paths if the Assets are in the same container the Document is in,
          or in a subcontainer of this container. If not, the path will be
          an absolute path.

        - Docma queue viewer is now on both import and export screen. On
          import only Silva XML files are shown, on export only Word
          documents.

        - Export screen prefills email address and description.

    Bugs Fixed

        - Fixed some bugs with copy/cut and paste: when an object is not
          allowed somewhere, it's now not possible to paste it there
          anymore, and also the id of the object to be pasted is now
          changed until it's unique (in the past, a bug in creating a
          unique id kept the status of a document 'public' in some cases).

        - Intermediate fix where an local roles mapping for an non-existing
          userid would display "Unknown User" and could not be deleted.

        - Past to ghost of Publications exposed two bugs. Fixed now. 

  0.9.1.1

    Bugs Fixed

        - UI bug where the cursor would behave inconsistently when
          hoovering buttons and buttonlinks.

        - Membership now supports member objects that have different ids
          than the userids. This is useful in LDAP setups where the userid
          may contain characters illegal in URLs, such as the @ sign.

        - Edit on pro transformations up to date.
    
  0.9.1

    Bugs Fixed

        - The "use selection" button would not return to tab_access 
          just after assigning a role to a user.

        - Changed from absolute_url(1) to getPhysicalPath() for 
          code elements - this should make code elements work in a
          virtual host setup.

        - Datasource parameters store empty strings instead of None
          for default values.

        - Fixed bug where the title of a SQLDatasource Asset was not 
          set in the edit tab.

        - Corrected access key in Indexer tabs.

        - Fixed tab_edit where Authors can't move anything and see
          an empty controls row.
        
        - Adjusted tab_edit and tab_status access key links so they
          work with Mozilla (select lists and checkbox labels).

        - Removed Mozilla incompatibility notes from help (since the
          problems are fixed).
        
        - Updated layout_macro to match presentation preview link in
          tab_preview.

        - Fixed location of closed message in tab_preview so it shows
          up regardless of which layout (public or default) gets used.
          Aligned presentation preview link better in default layout.

        - Fix where the Groups administration button was shown, even
          if no service_groups was available.      

        - Now refreshes all installed products before an 
          "upgrade all" action.

        - Fixed bug where a new connection id was not updated correctly 
          on the SQL Datasource Asset

        - Indexer objects now show up in public table of contents always
          if placed (before they never did).

        - File assets could only be added by users with manager role;
          this now only requires an Author role.

        - A memory leak exists in Zope 2.5.1 that is exposed by Silva in
          some cases when using the SMI. Zope 2.6.1 appears to fix this
          memory leak. Note though that while Zope 2.6.1 appears to work 
          with Silva, we haven't done extensive testing...

        - Fixed bug which cause the upgrade of all content to crash on
          CatalogedVersionedContent objects (e.g. SilvaNews NewsItems)

        - Chief editors could not add Groups or Virtual groups due to
          incorrect security settings; fixed.

  0.9.1 beta

    Features Added

        - Soft breaks in paragraphs (single enter).

        - Small API on Silva Root (add_silva_addable_forbidden() and
          clear_silva_addables_forbidden()) for absolutely forbidding
          visibility of certain meta_types in SMI. See also IRoot.py.
 
        - Improved tab_access user interface.

        - Group and VirtualGroup objects. Can be managed by going to
          'Group Administration' if Group product is installed. This
          makes group management a lot easier.

        - Optional message service ('service_message') which will send
          email on some workflow events.

        - Membership system. Different membership policies (working
          for instance with LDAP) can be plugged into Silva and
          enabled by placing a different Member Service
          ('service_members').

        - Access request system. A new UI so that users who do not
          have permissions to access a place can request roles on
          objects (optional).

        - New 'Data Source' is now enabled by default. The first
          implementation is an 'SQL Data Source' Asset. This can be
          used to import data from a relational database into a
          Document using the 'external data' element.

        - List titles have been removed and transformed into headings.
 
        - 'image_path' has been renamed to 'path' in the XML.

   Bugs Fixed

        - Fix where the "/manage" display link in the SMI tabs didn't
          didn't regard the local roles on the current object.

        - Asset reference fix where it didn't work in virtual host
          setups.

        - Fix some unicode issue related to tables (issue184)

        - Silva does no longer display non-installed content types
          in list of addables (issue159).

        - Modification time of assets should now be updated properly
          (issue147).

        - Some characters that were removed by the Silva editor
          shouldn't be removed -- made these work (issue 176).
  
        - New ('add') button should work properly again (issue 162).

        - Invalid image references now properly display error message
          (issue 204). 

  0.9.0.3

    Bugs Fixed

      - Merge from HEAD for add new object UI in tab-edit.

      - Fix where the "/manage" display link in the SMI tabs didn't
        regard the local roles on the current object.

      - Unicode fix for table rendering. Merge from HEAD branch.

      - Fix for asset reference to make it works in virtual host
        setups.

  0.9.0.2

    Bugs Fixed

      - When using LDAPUserManagement, a Attribute error on '_getOb'
        occured when adding Silva Images and -Files.

  0.9.0.1

    Bugs Fixed

      - After deleting a finished DocmaServer job, you are redirected
        to an existing page.

      - The (still disabled) externaldata element was registered wrong
        when enabled; fixed this (if you uncomment the code to enable it).
      
  0.9

    Features Added
 
        - Can change publication to folder and the reverse.

        - Links in editor now can have a 'target' option.
       
        - Images can now be hyperlinks.

        - Implementation of DataSource/DataElement for testing.

        - 'Code element' that can call arbitrary code included.
 
        - Access keys for common form buttons.

        - Integration of RealObjects editor (beta).

        - XML can be exported and imported.

        - Docma integration for importing/exporting to other document
          formats (like MS Word). This feature needs the separate
          Docma server (not yet released).

    Bugs Fixed

        - All '__index__.py' files are now non-empty, so that WinZip
          actually unpacks them...

        - Table edit bug fixed.

        - Table rendering code cleanup, better use of CSS

        - Memory leak fixed (really in ParsedXML and XMLWidgets).

        - Fix bug with wrong element-type selectors in editor.

        - Rename now provides better user feedback.

        - Definition list rendering bug fixed.

        - List rendering is now XHTML compliant.

        - Access restriction by role UI bug fixed.

        - ZMI find should now work better, thanks to bugfix in ParsedXML.

        - Lookup screen now accepts searches for people with names only
          2 characters big.

        - Lists with style no bullets are now rendered with p tag.

        - Pasted ghosts now obtain a last author.

        - Indexer is now addable by editor and up (used to be 
          manager only). Added note in UI that indexer works for published
          content only. Also fixed a bug in the Indexer; it now
          also indexes 'index' (default) documents.

        - Demo index document gets automatically added to new Silva root.

        - 'Authorized users below this level' moved to sub screen of
          access, to make container tab_metadata scale better (this
          could be very slow on large sites).
      
        - Tweaked LDAPUserFolder.py so it works with more recent versions
          of LDAPUserFolder.

        - Fixed problem in the Access tab, where the user lookup sometimes
          lost the current selection.

  0.8.6.1

    Bugs Fixed

        - RealObjects "edit-on Pro" integration improved.

        - FileSystemSite should now work on Windows install.

  0.8.6

    Features Added

       - Added Indexer object, which can find index entries and present
         them.

       - Enabled nested markup in text.

       - Added easier way to add references to files, images. Can now
         also reference assets not in local folder.

       - Ability to open/close branches of the site. Added a new
         'Viewer' role. Users with this role can see closed branches.

       - Request for approval now implemented; users can leave a message
         for the editors.

       - Added new definition list element.

       - Images now have various alignment options.

       - Moved views, widgets and other support folders to the
         filesystem, now using FileSystemSite.

       - Created new view registry called MultiViewRegistry which
         can deal with views from multiple Silva extension packages.
         View code can be maintained in extension packages apart from 
         the Silva core.

       - Created installation framework for Silva extension packages.
         'service_extensions' allows site managers to install new
         extension packages into a Silva install.

       - Beginnings of Silva XML import infrastructure.

    Bugs fixed

       - Changed some permissions so it's possible to display some
         information (publication datetime for instance) to end users.

       - Fixed various unicode errors.

       - Single column tables are now don't break.

       - Better 'no bullets' list style.

       - Fixed bug with extraneous list elements when too much
         whitespace was entered.

       - Fixed bug with ghosts pointing to nonexisting object.

       - Reenabled caching in editor.

       - Export newest version for XML exports now actually works.

       - Pipe characters are now not swallowed when entered in
         paragraphs, etc.

  0.8.5

    Features Added

      - New tab layout.

      - Short title in Silva Document and Silva Folder metadata.

      - Preformatted document element.      

      - Access restriction proof of concept.

      - Experimental editor support for nested markup. Replace
      "EditorSupport.py" with "EditorSupportNested.py" to test it.

      - Added file object.

    Bugs fixed

      - Non existing "tab" for an object, redirects to default tab
      ("tab_edit").

      - Restriction on single column tables removed.

      - Various character encoding related issues.

      - Removed non functional button from "tab_publish".

      - List title attribute migrated to title element in lists (the
      upgrade scripts from 0.8.4 to 0.8.5 will upgrade all content
      containing lists to this new XML format).

      - Display an informational message, if some view is not properly
      registered

      - UI tweaks and fixes.

  0.8.4

    Features Added

      - A Silva File object to store arbitrary file in either ZODB or on
        the filesystem.

      - Improved Access tab user interface.

      - First implementation of group access. Groups can be assigned
        local roles and managed from Silva. The groups system is only
        enabled if the optional Groups product is installed.

      - Improved object rename functionality; multiple items can now
        be renamed in one go.

      - More XML export options; XML can now be exported with or
        without sub publication. It is also possible to export the
        newest version of content instead of the public version.

      - Refactored Silva (API) Interfaces into separate files.

    Bugs Fixed

      - Less restrictive object id validation (underscore and period
        is allowed).

      - "addables" list is now sorted.

      - Paste as ghost for a folder now also ghosts the index.

      - many small UI tweaks and bugfixes.

  0.8.3

    Features Added

     - Beginnings of separating out the non-core objects from Silva core.

     - Some utility code in EditorSupport to support multi-column
     rendering.
      
     - Demo Object added to demonstrate how to extend Silva with new
     objects.
     
     - ChiefEditor and up can now configure what Silva Objects are
     addable in a Publication.
     
     - New "Reader" role, for readonly access to Silva Management 
     Interface (SMI).

     - Cleanup of "Add object" infrastructure.

     - Cleanup of ZMI tabs for Silva and XMLWidgets specific objects.

     - Logout link now works.

    Bugs Fixed

     - Some bug fixes to make plain Content objects (non-versioned) work
       better.

     - Some changes to Ghosts to make them work properly with virtual hosts.
     
     - SMI (Silva Management Interface)

        * Fix and cleanup of tabs_status code (thanks to Clemens Klein-
  Robbenhaar (a.o.) for reporting).

  * Fix of bug in Publish tab that occurred when no items selected.

     - Presentation Pagetemplates: 

        * Images "alt" attributes now show correct title.

        * Cleanup of index_html.

        * Removed "base" tag from layout_macro.html, fixed "script" tag,
        fixed "link" tag.

        * Changed call for "view_method" in content.html (thanks to
        Clemens Klein-Robbenhaar for reporting).

        * Changed spelling for override.html (thanks to Clemens Klein-
        Robbenhaar for reporting).

        * Various (cosmetic) changes in view/preview/tab-preview layout.  

  0.8.2

    (Internal release)
       
  0.8.1

    (Internal release) 

  0.8

    Initial Release

      - initial public release of Silva
